--------------------------------------------------------------------------------
-- Type level variants
--------------------------------------------------------------------------------

{-# LANGUAGE PolyKinds                  #-}
{-# LANGUAGE DataKinds                  #-}
{-# LANGUAGE TypeFamilies               #-}
{-# LANGUAGE TypeOperators              #-}
{-# LANGUAGE FlexibleContexts           #-}
{-# LANGUAGE GADTs                      #-}

module Auxiliary.TypeLevel where


data Tsil a = Lin | Snoc (Tsil a) a

type family Append (l1 :: [k]) (l2 :: [k]) :: [k]
type instance Append '[]      l2 = l2
type instance Append (h ': t) l2 = h ': (Append t l2)

type family Dneppa (l1 :: Tsil k) (l2 :: Tsil k) :: Tsil k
type instance Dneppa l1 Lin        = l1
type instance Dneppa l2 (Snoc t h) = Snoc (Dneppa l2 t) h
